"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:no-unused-expression no-empty */
var chai_1 = __importDefault(require("chai"));
var axios_1 = __importDefault(require("axios"));
var chai_as_promised_1 = __importDefault(require("chai-as-promised"));
var sinon_chai_1 = __importDefault(require("sinon-chai"));
var v3_1 = require("../../v3");
var index_1 = require("../index");
chai_1.default.use(sinon_chai_1.default);
chai_1.default.use(chai_as_promised_1.default);
var expect = chai_1.default.expect;
describe.skip('PactV4', function () {
    var pact = new index_1.PactV4({
        consumer: 'myconsumer',
        provider: 'myprovider',
        spec: v3_1.SpecificationVersion.SPECIFICATION_VERSION_V4,
        logLevel: 'debug',
    });
    describe('HTTP test', function () {
        it('returns a valid MATT message over HTTP', function () { return __awaiter(void 0, void 0, void 0, function () {
            var mattRequest, mattResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        mattRequest = "{\"request\": {\"body\": \"hello\"}}";
                        mattResponse = "{\"response\":{\"body\":\"world\"}}";
                        return [4 /*yield*/, pact
                                .addInteraction()
                                .given('the Matt protocol exists')
                                .uponReceiving('an HTTP request to /matt')
                                .usingPlugin({
                                plugin: 'matt',
                                version: '0.0.2',
                            })
                                .withRequest('POST', '/matt', function (builder) {
                                builder.pluginContents('application/matt', mattRequest);
                            })
                                .willRespondWith(200, function (builder) {
                                builder.pluginContents('application/matt', mattResponse);
                            })
                                .executeTest(function (mockserver) {
                                return axios_1.default
                                    .request({
                                    baseURL: mockserver.url,
                                    headers: {
                                        'content-type': 'application/matt',
                                        Accept: 'application/matt',
                                    },
                                    data: generateMattMessage('hello'),
                                    method: 'POST',
                                    url: '/matt',
                                })
                                    .then(function (res) {
                                    expect(parseMattMessage(res.data)).to.eq('world');
                                });
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
var parseMattMessage = function (raw) {
    return raw.replace(/(MATT)+/g, '').trim();
};
var generateMattMessage = function (raw) {
    return "MATT".concat(raw, "MATT");
};
//# sourceMappingURL=index.spec.js.map